'***************************************************************************
'                            DCF77-1.BAS
'                            Januar 2009
'                              (c) wh
'  
'***************************************************************************
'
'        Das DCF77 Protokoll wird mit diesem Programm nachgebildet,
'        dies erleichert den Test selbsterstellter Software zum
'        dekodieren des DCF77 Signals.
'
'        Ausgangspin RC,7 auf TB1, die LED in der Mitte blinkt.
'        Die Daten der DCF-Ausgabe sind fest auf:
'
'                  07:07 Uhr, 06.11.82
'
'        eingestellt.  Funktion OK
'
'        dcf77-1c.bas
'        Pin RC,0 1= Uhrzeit fest, 0= Minuten zhlen von 0 bis 59, Stunde ndert sich nicht
'        
'
'
         '$DEBUG

         define device il-troll
         
         
'Variablen und Konstanten definieren


         define uhr=  auto as word               'Interrupt gesteuerter Timer 0,1 Sekeunden
         define tmp1= auto as byte               'Temporre Variable 1
         define tmp2= auto as byte               'Temporre Variable 2
         define tmp3= auto as byte               'Temporre Variable 3
         define Info= auto as byte               'enthlt die Information, ie gesendet wird
         define count= auto as byte              'enthlt die Anzahl der gltigen Bit je Info-byte
                                                 'z.B. Minuten Einer enthlt 4 Bit
         define pruef= auto as byte              'Variable zum Erzeugen des Prfbit
         define timerx1=timerx                   'Systeminterne Variable timerx, auch unter timerx1 ansprechen
         define Minute= auto as byte             'Zhlvariable fr Minuten-einer
         define Minutz= auto as byte             'Zhlvariable fr Minuten-zehner
         
'Init         
         
         wait 500
         lcdinit rb,2,32
         
         clock uhr,100                           'Uhr wird alle 100ms um eins erhht
         
         let uhr =0                              'Variable Uhr auf Null setzen
         let pruef=0                             'Variable pruef auf Null setzen
         let Minute=0
         let Minutz=0
         high rc,7                               'Port Pin RC,7 Ausgang und Zustand High    
         inp rc,0                                'Port Pin RC,0 Eingang
         
         
         
start:
         'let tmp2=0 'nur test
         restore daten
         
         gosub lesen                   'Das erste Bit zur vollen Minute = Low
         gosub lesen                   'die ersten 8  von 14 Bit nicht zur DCF77 gehrenden Bit senden
         gosub lesen                   'die letzten 6 von 14 Bit nicht zur DCF77 gehrenden Bit senden
         gosub lesen                   '6 Bit Zonen- und Ankndigungs-Bits
         
         let pruef=0                   'Prfbit Zhler auf Null setzen, wird fr die Minuten bentigt
         
         
         if rc,0=0 then goto minfest   'Zhle im Minutentakt
         
         inc minute
         if Minute=10 then inc Minutz 
         if Minute=10 then let Minute=0
         if Minutz=6  then let Minutz=0
         
         let count=4
         let info=Minute
         gosub lesen1
         let count=3
         let info=Minutz
         gosub lesen1
         readdata info,count
         readdata info,count
         goto minup
         
         
         
minfest:         
         gosub lesen                   'Minuten Einer 4 Bit
         gosub lesen                   'Minuten Zehner 3 Bit
minup:         
         let info=pruef                'Prfbit 1 erzeugen, wenn Bit,0=1 dann 1 senden
         gosub ausgabe                 'Prfbit 1 ausgeben
         
         let pruef=0                   'Prfbit Zhler auf Null setzen, wird fr die Minuten bentigt
         gosub lesen                   'Stunden Einer 4 Bit
         gosub lesen                   'Stunden Zehner 2 Bit
         let info=pruef                'Prfbit 2 erzeugen, wenn Bit,0=1 dann 1 senden
         gosub ausgabe                 'Prfbit 2 ausgeben
         
         let pruef=0                   'Prfbit Zhler auf Null setzen, wird fr die Minuten bentigt
         gosub lesen                   'Kalendertag Einer 4 Bit
         gosub lesen                   'Kalendertag Zehner 2 Bit
         gosub lesen                   'Wochentag 3 Bit, Montag=1
         gosub lesen                   'Kalendermonat Einer 4 Bit
         gosub lesen                   'Kalendermonat Zehner 1 Bit
         gosub lesen                   'Kalenderjahr Einer 4 Bit
         gosub lesen                   'Kalenderjahr Zehner 4 Bit
         let info=pruef                'Prfbit 3 erzeugen, wenn Bit,0=1 dann 1 senden
         gosub ausgabe                 'Prfbit 3 ausgeben
         
         wait 1000                     '59 Sekunde ohne Implus
         
         goto start                    'Wieder von vorne
         

lesen:           'liest die Daten-Byte aus den DATA-Zeilen
                   
         
         readdata info,count
         
lesen1:                                'Einsprung fr Minutenzhler
         
         for tmp1=1 to count           'Prfe nur die gltigen Bit im Info-Byte 
         
         gosub ausgabe                 'Gib den Impuls frei
          
         rotr info                     'Schiebe Bit1 auf Postion von Bit 0, damit es geprft werden kann
         next tmp1                     'Nchstes Bit
         return
         
ausgabe:           'Erzeugt die Bitlnge 1= 200ms, 0= 100ms
         'inc tmp2 'nur test
         if info,0= 1 then inc pruef   'Prfbit Zhler ums eins erhhen
         let timerx=0                  'Timer auf Null setzen
         let uhr=0                     'Timer auf Null setzen
         res rc,7                      'Ausgang auf low
         if info,0 = 1 then goto aus1  ' Wenn Bit 0=1 dann Impuls 200ms lang
         
aus0:
         if uhr,0=1 then goto aus3     'warte 100ms
         let tmp3=0                    'warte einen Zyklus
         goto aus0                     'weiter warten
aus1:  
         if uhr,1=1 then goto aus3     'warte 200ms
         let tmp3=0                    'warte einen Zyklus
         goto aus1                     'weiter warten
aus3:
         set rc,7                      'Ausgang auf High
         'lcdwrite 1,1,tmp2 'nur test
         if uhr=10 then goto aus4      'warte bis eine sekunde voll
         let tmp3=0                    'warte einen Zyklus
         goto aus3                     'weiter warten
aus4:        

         return


         
daten:

         data 0,1                      'Das erste Daten Bit zur vollen Minute = Low        
         data 0,8                      'Die ersten 14 Bit werden nicht fr die DCF-Uhr verwendet
         data 0,6                      '       "             "                  "
         
         data 8,6                      'Zonen- und Ankndigungs-Bits, auf MEZ eingestellt -> 6 Bit
         
         data 7,4                      'Minuten-Einer auf 2 -> 4 Bit
         data 0,3                      'Minuten-Zehner auf 10 -> 3 Bit
         
         data 7,4                      'Stunden-Einer auf 8 -> 4 Bit
         data 0,2                      'Stunden-Zehner auf 0 ->2 Bit
         
         data 6,4                      'Kalendertag-Einer auf 6 -> 4 Bit
         data 0,2                      'Kalendertag-Zehner auf 0 -> 2 Bit
         
         data 4,3                      'Wochentag 1=Montag etc.   -> 3 Bit
         
         data 1,4                      'Kalendermonat-Einer 1 -> 4 Bit
         data 1,1                      'Kalendermonat-Zehner 1 -> 1 Bit
         
         data 2,4                      'Kalenderjahr-Einer 2 -> 4 Bit
         data 8,4                      'Kalenderjahr-Zehner 8 -> 4 Bit
         data 0,8                      'Nur Dummy
         
         
         
         END
         
         
         
         
         